if (!defined &_SYS_PROC_H_) {
    eval 'sub _SYS_PROC_H_ {1;}';
    require 'machine/proc.ph';
    require 'sys/select.ph';
    require 'sys/queue.ph';
    eval 'sub p_ucred { &p_cred-> &pc_ucred;}';
    eval 'sub p_rlimit { &p_limit-> &pl_rlimit;}';
    eval 'sub p_startzero { &p_oppid;}';
    eval 'sub p_endzero { &p_startcopy;}';
    eval 'sub p_startcopy { &p_sigmask;}';
    eval 'sub p_endcopy { &p_thread;}';
    eval 'sub p_session { &p_pgrp-> &pg_session;}';
    eval 'sub p_pgid { &p_pgrp-> &pg_id;}';
    eval 'sub SIDL {1;}';
    eval 'sub SRUN {2;}';
    eval 'sub SSLEEP {3;}';
    eval 'sub SSTOP {4;}';
    eval 'sub SZOMB {5;}';
    eval 'sub P_ADVLOCK {0x00001;}';
    eval 'sub P_CONTROLT {0x00002;}';
    eval 'sub P_INMEM {0x00004;}';
    eval 'sub P_NOCLDSTOP {0x00008;}';
    eval 'sub P_PPWAIT {0x00010;}';
    eval 'sub P_PROFIL {0x00020;}';
    eval 'sub P_SELECT {0x00040;}';
    eval 'sub P_SINTR {0x00080;}';
    eval 'sub P_SUGID {0x00100;}';
    eval 'sub P_SYSTEM {0x00200;}';
    eval 'sub P_TIMEOUT {0x00400;}';
    eval 'sub P_TRACED {0x00800;}';
    eval 'sub P_WAITED {0x01000;}';
    eval 'sub P_WEXIT {0x02000;}';
    eval 'sub P_EXEC {0x04000;}';
    eval 'sub P_OWEUPC {0x08000;}';
    eval 'sub P_FSTRACE {0x10000;}';
    eval 'sub P_SSTEP {0x20000;}';
    eval 'sub P_SUGIDEXEC {0x40000;}';
    eval 'sub P_NOCLDWAIT {0x80000;}';
    if (defined &_KERNEL) {
	eval 'sub PID_MAX {30000;}';
	eval 'sub NO_PID {30001;}';
	eval 'sub SESS_LEADER {
	    local($p) = @_;
	    eval "(($p)-> &p_session-> &s_leader == ($p))";
	}';
	eval 'sub SESSHOLD {
	    local($s) = @_;
	    eval "(($s)-> &s_count++)";
	}';
	eval 'sub SESSRELE {
	    local($s) = @_;
	    eval "{  &if (--($s)-> &s_count == 0)  &FREE($s,  &M_SESSION); }";
	}';
	eval 'sub PHOLD {
	    local($p) = @_;
	    eval "{  &if (($p)-> &p_holdcnt++ == 0 && (($p)-> &p_flag &  &P_INMEM) == 0)  &swapin($p); }";
	}';
	eval 'sub PRELE {
	    local($p) = @_;
	    eval "(--($p)-> &p_holdcnt)";
	}';
	eval 'sub PIDHASH {
	    local($pid) = @_;
	    eval "(& $pidhashtbl[($pid) &  &pidhash])";
	}';
	eval 'sub PGRPHASH {
	    local($pgid) = @_;
	    eval "(& $pgrphashtbl[($pgid) &  &pgrphash])";
	}';
	eval 'sub NQS {32;}';
    }
}
1;
